<?php

function tc_json_serialize($str)
{
    if (function_exists("json_encode"))
    {
        return json_encode($str);
    }
    else
    {
        if (is_int($str))
        {
            return (string )$str;
        }
        else if (is_string($str))
        {
            $str = str_replace(array('\\', '/', '"', "\r", "\n", "\b", "\f", "\t")
                , array('\\\\', '\/', '\"', '\r', '\n', '\b', '\f', '\t'), $str);

            $convmap = array(0x80, 0xFFFF, 0, 0xFFFF);
            $result = "";

            for ($i = mb_strlen($str) - 1; $i >= 0; $i--)
            {
                $mb_char = mb_substr($str, $i, 1);
                $match = array();

                if (mb_ereg("&#(\\d+);", mb_encode_numericentity($mb_char, $convmap, "UTF-8"), $match))
                {
                    $result = sprintf("\\u%04x", $match[1]) . $result;
                }
                else
                {
                    $result = $mb_char . $result;
                }
            }

            return '"' . $result . '"';
        }
        else if (is_float($str))
        {
            return str_replace(",", ".", $str);
        }
        else if (is_null($str))
        {
            return 'null';
        }
        else if (is_bool($str))
        {
            return $str ? 'true' : 'false';
        }
        else if (is_array($str))
        {
            $with_keys = false;
            $n = count($str);

            for ($i = 0, reset($str); $i < $n; $i++, next($str))
            {
                if (key($str) !== $i)
                {
                    $with_keys = true;
                    break;
                }
            }
        }
        else if (is_object($str))
        {
            $with_keys = true;
        }
        else
        {
            return '';
        }

        $result = array();

        if ($with_keys)
        {
            foreach ($str as $key => $v)
            {
                $result[] = tc_json_serialize((string)$key) . ':' . tc_json_serialize($v);
            }

            return '{' . implode(',', $result) . '}';
        }
        else
        {
            foreach ($str as $key => $v)
            {
                $result[] = tc_json_serialize($v);
            }

            return '[' . implode(',', $result) . ']';
        }
    }
}

function tc_prcrypt($str, $key = "TubeContext@Player")
{
    $str = tc_json_serialize($str);

    $_bin2hex = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f');
    $_aKey = array();

    for ($i = 0; $i < 256; $i++)
    {
        $_aKey[$i] = $i;
    }

    $jk = 0;
    $xk = 0;

    for ($ik = 0; $ik < 256; $ik++)
    {
        $jk = ($jk + $_aKey[$ik] + ord($key[$ik % strlen($key)])) % 256;

        $xk = $_aKey[$ik];
        $_aKey[$ik] =$_aKey[$jk];
        $_aKey[$jk] = $xk;
    }

    $key = $_aKey;
    $i = 0;
    $j = 0;

    for ($y = 0; $y < strlen($str); $y++)
    {
        $i = ($i + 1) % 256;
        $j = ($j + $key[$i]) % 256;
        $x = $key[$i];
        $key[$i] = $key[$j];
        $key[$j] = $x;
        $ch = $str[$y] ^ chr($key[($key[$i] + $key[$j]) % 256]);

        $chOrd = ord($ch);
        print $_bin2hex[($chOrd & 0xf0) >> 4];
        print $_bin2hex[($chOrd & 0x0f)];
    }
}

?>